Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 496446 - dev-util/boost-build-1.55.0: fails to build on default/linux/mips/13.0/mipsel/multilib/n32 with USE=python
Summary: dev-util/boost-build-1.55.0: fails to build on default/linux/mips/13.0/mipsel...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: [OLD] Library (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: C++ Team [disbanded]
URL:
Whiteboard:
Keywords:
: 505694 (view as bug list)
Depends on:
Blocks:
 
Reported: 2013-12-29 23:57 UTC by Anthony Basile
Modified: 2014-05-16 11:28 UTC (History)
3 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build log failure for boots-build-1.53.0 on multilibe mips64el (boost-build-1.53.0-build.log,12.26 KB, text/plain)
2013-12-29 23:58 UTC, Anthony Basile
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Anthony Basile gentoo-dev 2013-12-29 23:57:19 UTC
This bug doesn't affect various amd64, arm or x86 profiles, but it does affect (at least) mipsel multilib o32/n32/n64 with n32 default.  Running the ebuild as its written ends in multiple instances of

compilation terminated.
In file included from glob.c:27:0:
jam.h:42:20: fatal error: Python.h: No such file or directory
 #include <Python.h>
                    ^

If, however, we apply the following patch:

--- /usr/portage/dev-util/boost-build/boost-build-1.53.0.ebuild	2013-02-12 15:39:04.000000000 +0000
+++ boost-build-1.53.0.ebuild	2013-12-29 23:12:57.160032157 +0000
@@ -88,7 +88,7 @@
 		toolset=cc
 	fi
 
-	CC=$(tc-getCC) ./build.sh ${toolset} -d+2 $(use_with python python "${EROOT}"/usr) || die "building bjam failed"
+	CC=$(tc-getCC) ./build.sh ${toolset} -d+2 $(use_with python) || die "building bjam failed"
 }
 
 src_install() {


it does build, ie replace $(use_with python python "${EROOT}"/usr) with $(use_with python).  I'm sorry I can't give you more, I don't understand boost's internals well enough.

Reproducible: Always
Comment 1 Anthony Basile gentoo-dev 2013-12-29 23:58:06 UTC
Created attachment 366508 [details]
build log failure for boots-build-1.53.0 on multilibe mips64el
Comment 2 Anthony Basile gentoo-dev 2014-01-05 16:39:48 UTC
cc-ing the python team since they might have a clue.
Comment 3 Anthony Basile gentoo-dev 2014-05-15 14:56:24 UTC
This is still an issue with 1.55.0.
Comment 4 Tiziano Müller (RETIRED) gentoo-dev 2014-05-15 17:40:35 UTC
Well, looking at the following lines in build.jam, the proposed patch just disables python-support entirely:

  [...]
  # Enable, and configure, Python hooks.
  with-python = ;
  python-location = [ MATCH --with-python=(.*) : $(ARGV) ] ;
  if $(python-location)
  {
      with-python = true ;
  }
  if $(with-python)
  {
  [...]

so, questions are:

* what do we end up with as ${PYTHON_ABI} ? ... please attach engine/build.jam since we patch that
* does the calculated python directory (usually /usr/include/python2.7) exist on that specific arch?

Besides, we should finally port the boost-build ebuild to python-single-r1
Comment 5 Sergey Popov gentoo-dev 2014-05-16 09:40:30 UTC
Actually, improper libdir was a culprit. Fixed now, thanks for the report

+  16 May 2014; Sergey Popov <pinkbyte@gentoo.org> boost-build-1.53.0.ebuild,
+  boost-build-1.54.0.ebuild, boost-build-1.55.0.ebuild:
+  Respect multilib during building Python-related stuff, bug #496446
Comment 6 Sergey Popov gentoo-dev 2014-05-16 10:20:30 UTC
*** Bug 505694 has been marked as a duplicate of this bug. ***
Comment 7 Tiziano Müller (RETIRED) gentoo-dev 2014-05-16 11:28:07 UTC
(In reply to Sergey Popov from comment #5)
> Actually, improper libdir was a culprit. Fixed now, thanks for the report

ok, so the glob returned empty and --python-include was not set.
good job, thanks.